<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="设备状态" prop="status">
        <el-select v-model="queryParams.status" clearable @keyup.enter.native="handleQuery">
          <el-option key="0" label="被领用" value="0">
          </el-option>
          <el-option key="1" label="可领用" value="1">
          </el-option>
          <el-option key="2" label="维修中" value="2">
          </el-option>
          <el-option key="3" label="已停用" value="3">
          </el-option>
          <el-option key="4" label="已报废" value="4">
          </el-option>
          <el-option key="5" label="已处置" value="5">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="出厂编号" prop="name">
        <el-input v-model="queryParams.code" placeholder="请输入出厂编号" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="设备名称" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入设备名称" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="设备品牌" prop="brand">
        <el-input v-model="queryParams.brand" placeholder="请输入设备品牌" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-form-item label="规格型号" prop="series">
          <el-input v-model="queryParams.series" placeholder="请输入规格型号" clearable @keyup.enter.native="handleQuery" />
        </el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['oa:device:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['oa:device:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['oa:device:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['oa:device:export']">导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="info" plain icon="el-icon-edit" size="mini" @click="handleUpdateDayCost"
          v-hasPermi="['oa:device:edit']">修改成本</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" border :data="deviceList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="设备编号" align="center" prop="deviceNumber" />
      <el-table-column label="设备状态" align="center" prop="status">
        <template slot-scope="scope">
          <el-tag :type="statusTypeStyle(scope.row.status)">{{ statusTypeText(scope.row.status) }}</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="设备品牌" align="center" prop="brand" />
      <el-table-column label="设备名称" align="center" prop="name" />
      <!-- <el-table-column label="设备类别" align="center" prop="type" /> -->
      <el-table-column label="规格型号" align="center" prop="series" />
      <el-table-column label="出厂编号" align="center" prop="code" />
      <el-table-column label="购置时间" align="center" prop="acquisitionTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.acquisitionTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="购买价格（元）" align="center" prop="cost" />
      <el-table-column label="预计使用年限" align="center" prop="expectLife" />
      <el-table-column label="单日成本（元）" align="center" prop="dayCost" />
      <!-- <el-table-column label="存放地点" align="center" prop="place" />
      <el-table-column label="管理部门" align="center" prop="dept.deptName" /> -->
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">

        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-view" @click="handleAddDetail(scope.row)"
            v-hasPermi="['oa:device:query']">查看明细</el-button>
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['oa:device:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" style="color: #fc0000;"
            @click="handleDelete(scope.row)" v-hasPermi="['oa:device:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改cmc设备信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="设备品牌" prop="brand">
              <el-input v-model="form.brand" placeholder="请输入设备品牌" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="设备名称" prop="name">
              <el-input v-model="form.name" placeholder="请输入设备名称" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="设备类别" prop="type">
              <el-select v-model="form.type" placeholder="请输入设备类别">
                <el-option label="仪器设备" value="仪器设备">
                </el-option>
                <el-option label="办公设备" value="办公设备">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="规格型号" prop="series">
              <el-input v-model="form.series" placeholder="请输入规格型号" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="购置时间" prop="acquisitionTime">
              <el-date-picker clearable v-model="form.acquisitionTime" type="date" value-format="yyyy-MM-dd"
                placeholder="请选择购置时间">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="存放地点" prop="place">
              <el-input v-model="form.place" placeholder="请输入存放地点" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="购买价格" prop="cost">
              <el-input style="width:130px;margin-right:10px;" v-model="form.cost" placeholder="请输入金额" />
              <span>元</span>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="预计使用年限" prop="expectLife">
              <el-input v-model="form.expectLife" placeholder="请输入年限" style="width:130px;margin-right:10px;" />
              <span>年</span>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="出厂编号" prop="code">
              <el-input type="textarea" :rows="2" v-model="form.code" placeholder="请输入出厂编号" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="单日成本" prop="dayCost">
              <el-input type="textarea" :rows="2" style="width:230px;margin-right:10px;" v-model="form.dayCost"
                placeholder="请输入单日成本" />
              <span>元</span>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="管理部门" prop="manageDept">
              <el-select v-model="form.manageDept" filterable placeholder="请选择" clearable>
                <el-option v-for="item in $store.state.user.deptList" :key="item.deptId" :label="item.deptName"
                  :value="item.deptId">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="设备状态" prop="status">
              <el-select v-model="form.status" filterable placeholder="请选择">
                <el-option v-for="item in statusList" :key="item.id" :label="item.name" :value="item.id">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="备注" prop="remark">
              <el-input type="textarea" v-model="form.remark" placeholder="请输入备注" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="设备编号" prop="deviceNumber">
              <el-input v-model="form.deviceNumber" placeholder="请输入设备编号" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>

      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listDevice, getDevice, delDevice, addDevice, updateDevice, updateDayCost } from "@/api/oa/device/device";
import { listDept } from '@/api/system/dept'

export default {
  name: "Device",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // cmc设备信息表格数据
      deviceList: [],
      deptList: [],
      statusList: [{ id: '0', name: '被领用' }, { id: '1', name: '可领用' }, { id: '2', name: '维修中' }, { id: '3', name: '已停用' }, { id: '4', name: '已报废' }, { id: '5', name: '已处置' }],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 50,
        code: null,
        type: '仪器设备',
        acquisitionTime: null,
        cost: null,
        expectLife: null,
        series: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [
          { required: true, message: '请输入设备名称', trigger: 'blur' }
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getDeptList();
  },
  methods: {
    /** 查询cmc设备信息列表 */
    getList() {
      this.loading = true;
      listDevice(this.queryParams).then(response => {
        this.deviceList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getDeptList() {
      listDept({ pageSize: 9999, pageNum: 1 }).then(res => {
        this.deptList = res.data
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        deviceId: null,
        code: null,
        type: null,
        acquisitionTime: null,
        cost: null,
        expectLife: null,
        series: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.deviceId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加设备信息";
    },
    // 新增明细按钮
    handleAddDetail(row) {
      this.$router.push({
        path: '/device/detail',
        query: {
          type: 'equipment',
          deviceId: row.deviceId,
        }
      })
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const deviceId = row.deviceId || this.ids
      getDevice(deviceId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改设备信息";
      });
    },
    /** 修改成本按钮操作 */
    handleUpdateDayCost() {
      this.reset();
      updateDayCost(this.form).then(response => {
        this.$modal.msgSuccess("修改成功");
        this.open = false;
        this.getList();
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.deviceId != null) {
            updateDevice(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addDevice(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const deviceIds = row.deviceId || this.ids;
      const code = row.code
      this.$modal.confirm('是否确认删除设备编号为【"' + code + '"】的设备数据？').then(function () {
        return delDevice(deviceIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('oa/device/export', {
        ...this.queryParams
      }, `device_${new Date().getTime()}.xlsx`)
    },
    statusTypeText(row) {
      if (row == '0') {
        return '被领用'
      }
      if (row == '1') {
        return '可领用'
      }
      if (row == '2') {
        return '维修中'
      }
      if (row == '3') {
        return '已停用'
      }
      if (row == '4') {
        return '已报废'
      }
      if (row == '5') {
        return '已处置'
      }
    },
    statusTypeStyle(row) {
      if (row == '0') {
        return 'warning'
      }
      if (row == '1') {
        return 'success'
      }
      if (row == '2') {
        return 'primary'
      }
      if (row == '3') {
        return 'danger'
      }
      if (row == '4') {
        return 'info'
      }
      if (row == '5') {
        return ''
      }
    }
  }
};
</script>
